#!/usr/bin/perl -w

# cette librairie sert &agrave; mieux afficher les erreurs, vous la palcez o&ugrave; vous voulez dans votre r&eacute;pertoire et changez le chemin ci-dessous en correspondance
BEGIN {unshift(@INC, '/usr/lib/perl5/5.005/');}
use CGI::Carp qw(carpout fatalsToBrowser croak confess);

# fichier test
my $test = 'truncate.txt';
my $test_www = 'truncate.txt';


# pour simuler la fonction gensym de la librairie Symbol
package My_symbol;
my $genpkg = "My_symbol::";
my $genseq = 0;
sub gensym () {
    my $name = "GEN" . $genseq++;
    local *{$genpkg . $name};
    \delete ${$genpkg}{$name};
}

package main;

# position pour SEEK
my $SEEK_SET = 0;
 
print "Content-type: text/html\n\n";
print<<EOF
<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<HTML><HEAD><TITLE>Truncate de $test</TITLE></HEAD>
<body> 
EOF
;
print "<h1 align=center>Truncate de $test</h1>\n";

print "Truncate tronque un fichier. Pour cel&agrave;, il a besoin de conna&icirc;tre le fichier voulu. On le lui indique soit en lui donnant son nom ou son HANDLER, directement ou par une variable. Ce HANDLER peut &ecirc;tre choisi ou g&eacute;n&eacute;r&eacute; par une fonction. Dans l'absolu, tout devrait passer, dans la pratique, selon les impl&eacute;mentations de perl, certains cas peuvent produire une erreur.<BR><BR>";

print "On va d'abord cr&eacute;er le fichier $test et y &eacute;crire: abc<br><br>\n";
my $fh = My_symbol::gensym();
open($fh, ">$test") || confess("Can't open $test: $!");
print $fh "abc\n";
close($fh) || confess("probl&egrave;me de cl&ocirc;ture avec $test: $!");

print "On rouvre et tronque $test:<br>\n";
open($fh, "+<$test") || confess("Can't open $test: $!");
seek($fh,0,$SEEK_SET);
if (truncate($test, 0)) {
  print "<strong>Truncate r&eacute;ussi avec nom du fichier</strong>, on &eacute;crit 'd'<br>\n";
  print $fh "d\n";
} else {print "<strong>Truncate rat&eacute; avec nom du fichier</strong><br>\n";}
if (truncate($fh, 0)) {
  print "<strong>Truncate r&eacute;ussi avec HANDLER g&eacute;n&eacute;r&eacute; par gensym</strong>, on &eacute;crit 'e'<br>\n";
  print $fh "e\n";
} else {print "<strong>Truncate rat&eacute; avec HANDLER g&eacute;n&eacute;r&eacute; par gensym</strong><br>\n";}
close($fh) || confess("probl&egrave;me de cl&ocirc;ture avec $test: $!");

print "<br>On le rouvre, le tronque:<br>\n";
open(TEST, "+<$test") || confess("Can't open $test: $!");
seek(TEST,0,$SEEK_SET);
if (truncate(TEST, 0)) {
  print "<strong>Truncate r&eacute;ussi avec HANDLER manuel</strong>, on &eacute;crit 'f'<br>\n";
  print TEST "f\n";
} else {print "<strong>Truncate rat&eacute; avec HANDLER manuel</strong><br>\n";}
close(TEST) || confess("probl&egrave;me de cl&ocirc;ture avec $test: $!");

print "<br>On le rouvre, le tronque:<br>\n";
$fh = TEST;
open($fh, "+<$test") || confess("Can't open $test: $!");
seek($fh,0,$SEEK_SET);
if (truncate($fh, 0)) {
  print "<strong>Truncate r&eacute;ussi avec HANDLER manuel pass&eacute; par une variable \$fh=TEST</strong>, on &eacute;crit 'g'<br>\n";
  print $fh "g\n";
} else {print "<strong>Truncate rat&eacute; avec HANDLER manuel pass&eacute; par une variable \$fh=TEST</strong><br>\n";}
close($fh) || confess("probl&egrave;me de cl&ocirc;ture avec $test: $!");

print "<BR>Si l'un au moins des truncate a r&eacute;ussi, vous devez lire dans le fichier une seule lettre correspondant au dernier truncate r&eacute;ussi.";
print "<br><A HREF=\"$test_www\">Voir le fichier: $test</A><BR>\n";
print "</body></html>";
